#include <bits/stdc++.h>

using namespace std;
int main()
{
    int t;
    cin >> t;
    int n, k, neg, pos;
    cin >> n >> k;
    vector<int> misl = vector<int>(n);
    for(int i = 0; i < n; i++)
    {
        cin >> misl[i];
        if(misl[i] < 0) neg++;
        if(misl[i] > 0) pos++;
    }
    sort(misl.begin(), misl.end());
    if((n + k) % 2 == 1) cout << "NE";
    else
    {
        int x = (n + k) / 2;
        vector<int> v1 = vector<int>(n);
        if(pos >= x)
        {
            for(int i = 0; i < n; i++)
            {
                if(i < x)
                {
                    v1[i] = misl[n - x + i];
                }
                else
                {
                    v1[i] = misl[n - 1 - i];
                }
            }
        }
        else
        {
            for(int i = 0; i < n; i++)
            {
                if(i < n - x)
                {
                    v1[i] = misl[(n - x) - i - 1];
                }
                else
                {
                    v1[i] = misl[i];
                }
            }
        }
        int tek = 0;
        for(int i = 0; i < n; i++)
        {
            if(tek > v1[i]) tek--;
            else tek++;
            //cout << v1[i] << " ";
        }
        if(tek == k)
        {
            cout << "DA";
            if(t == 1)
            {
                cout << "\n";
                for(int i = 0; i < n; i++)
                {
                    cout << v1[i] << " ";
                }
            }
        }
        else
        {
            cout << "NE";
        }
        //cout <<"\n" << tek;
    }
}